#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "hello_world4xi.py">
#<abstract4xi abstract = "hello world in multiprocessing"/>
#<refer4xi reference = "DragonXi"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
#<verify4xi verification = "10" target = "process4xi.py"/>
#<contextualize4xi context = "pipe4xi.py; forkingpickler4xi.py; popen4xi.py; current_process4xi.py"/>
# ------------------------------------------------------------------------------------------------- 

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'print_trace4xi',
            'set_trace4xi',
            'f4xi',
            'f2xi',
            'f']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import sys
import _winapi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing import Process
from multiprocessing import freeze_support
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from process2xi import Process2Xi

from current_process4xi import CurrentProcess4Xi

from current_process4xi import init_all_current_process4xi
from current_process4xi import set_all_current_process4xi
from current_process4xi import get_all_current_process4xi
from current_process4xi import get_one_current_process4xi
from current_process4xi import value_current_process4xi
#1
from current_process4xi import init_current_process4xi
from current_process4xi import get_current_process4xi
from current_process4xi import set_current_process4xi
#2
from current_process4xi import init_inheriting_current_process4xi
from current_process4xi import get_inheriting_current_process4xi
from current_process4xi import set_inheriting_current_process4xi
#3
from current_process4xi import init_authkey_current_process4xi
from current_process4xi import get_authkey_current_process4xi
from current_process4xi import set_authkey_current_process4xi
#4
from current_process4xi import init_identity_current_process4xi
from current_process4xi import get_identity_current_process4xi
from current_process4xi import set_identity_current_process4xi
#5
from current_process4xi import init_name_current_process4xi
from current_process4xi import get_name_current_process4xi
from current_process4xi import set_name_current_process4xi
#6
from current_process4xi import init_counter_current_process4xi
from current_process4xi import get_counter_current_process4xi
from current_process4xi import set_counter_current_process4xi
#7                             
from current_process4xi import init_daemonic_current_process4xi
from current_process4xi import get_daemonic_current_process4xi
from current_process4xi import set_daemonic_current_process4xi
#8                             
from current_process4xi import init_tempdir_current_process4xi
from current_process4xi import get_tempdir_current_process4xi
from current_process4xi import set_tempdir_current_process4xi
#9
from current_process4xi import add_child_current_process4xi
from current_process4xi import discard_child_current_process4xi
from current_process4xi import get_children_current_process4xi
#10                             
from current_process4xi import init_manager_server_current_process4xi
from current_process4xi import get_manager_server_current_process4xi
from current_process4xi import set_manager_server_current_process4xi

from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi 
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi
      
from process4xi import Process4Xi

from print4xi import Print4Xi

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

           

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'Pipe4Xi': 'NACK4TRACE', 
        'PipeConnection4Xi': 'NACK4TRACE',
        'Popen4Xi': 'NACK4TRACE',
        'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        '_ConnectionBase4Xi': 'NACK4TRACE'
        }                             
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Pipe4Xi
        # PipeConnection4Xi
        # Popen4Xi
        # Process4Xi
        # Queue4Xi
        # _ConnectionBase4Xi
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    # 05:59:28 02/11/13 Pacific Standard Time

    
#</function4xi>     

# -------------------------------------------------------------------------------------------------
#<function4xi function = "f" usage = "
# Step 1/3 hello world from Standard Multiprocessing!
#">                       
# ------------------------------------------------------------------------------------------------- 

def f():
    print('=' *80)
    print ('(Step 1/3) of hello world from Standard Multiprocessing!')
    print('=' *80)
        
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "f2xi" usage = "
# Step 2/3 hello world from Dragon2Xi multiprocessing2xi!
#">                         
# ------------------------------------------------------------------------------------------------- 
    
def f2xi():
    print('=' *80)
    print ('(Step 2/3) of hello world from Dragon2Xi multiprocessing2xi!') 
    print('=' *80)    
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "f4xi" usage = "
#   Step 3/3a hello world from Dragon4Xi Multiprocessing4xi!
#">                         
# ------------------------------------------------------------------------------------------------- 

def f4xi():
    print('=' *80)
    print ('(Step 3/3) of hello world from Dragon4Xi Multiprocessing4xi!')     
    print('=' *80)    
#</function4xi>
 

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   printing trace
#">                    
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-hello-world4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Hello World in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Hello World in Multiprocessing.</rdfs:comment>\n'}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-hello-world4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Hello World in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Hello World in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-hello-world4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Hello World in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Hello World in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
  
# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase1" usage = "
#   main of hello_world4xi
#">                               
# -------------------------------------------------------------------------------------------------           
def phase1():

    # -----------------------------------------------------------------------------------------    
    # (STEP 1/3)- OK
    # -----------------------------------------------------------------------------------------    
    print("(STEP 1/3A) PHASE1 OF HELLO_WORLD4XI - STANDARD MULTIPROCESSING STARTED ", time4xi())
    # 05:59:28 02/11/13 Pacific Standard Time
    
    ack2p = False 
    nack2p = True
    
    try:
        freeze_support()
        
        p = Process(target=f) #Process(target=f).start()  
    
        print("(STEP 1/3B1) PHASE1 OF HELLO_WORLD4XI - CREATED PROCESS: ", p)    
        # <Process(Process-1, initial)>
        
        ack2p = True
    except:
        print("(STEP 1/3C) PHASE1 OF HELLO_WORLD4XI *** FAILED TO CREATE PROCESS *** ", time4xi())
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    
    if ack2p is  True:
                
        print("(STEP 1/3D) PHASE1 OF HELLO_WORLD4XI:  ALIVE STATUS AFTER CREATION: ", p.is_alive())  
        # False - OK        
        
        p.start()
        
        print("(STEP 1/E) PHASE1 OF HELLO_WORLD4XI:  ALIVE STATUS AFTER START: ", p.is_alive())     
        # True - OK
        
        
        p.run()
        
        print("(STEP 1/F) PHASE1 OF HELLO_WORLD4XI:  ALIVE STATUS AFTER RUN: ", p.is_alive()) 
        #================================================================================
        #(Step 1/3) of hello world from Standard Multiprocessing!
        #================================================================================         
        # True - OK        
        
        p.terminate()
    
        print("(STEP 1/G) PHASE1 OF HELLO_WORLD4XI:  ALIVE STATUS AFTER TERMINATE: ", p.is_alive())  
        # True - OK !
        
    else:
        print("(STEP 1/3H) ** PHASE1 OF HELLO_WORLD4XI - SKIPPED MORE EXPLORATION - NON-EXISTING PROCESS ** ", time4xi()) 
 
#</function4xi>        
           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase2" usage = "
#   main of hello_world2xi
#">                               
# -------------------------------------------------------------------------------------------------           
def phase2():

    # -----------------------------------------------------------------------------------------    
    # (STEP 2/3)
    # ----------------------------------------------------------------------------------------- 
       
    print("(STEP 2/3a) OF PHASE2 OF HELLO_WORLD - MULTIPROCESSING2XI STARTED ", time4xi())
    # 05:59:28 02/11/13 Pacific Standard Time
    
    ack2p = False
    nack2p = True
    
    try:
        freeze_support()
        
        p2xi = Process2Xi(target=f2xi)   
        
        print('~' *21)    
        print("(STEP 2/3b) OF PHASE2 OF HELLO_WORLD - CREATED PROCESS: ", p2xi)
        print('~' *21)            
        # <Process2Xi(Process2Xi-2, initial)>
        
        ack2p = True
    except:
    
        print("(STEP 2/3c) *** OF PHASE2 OF HELLO_WORLD - FAILED TO CREATE PROCESS2XI *** ", time4xi())
 
    # -----------------------------------------------------------------------------------------    
    #
    # ----------------------------------------------------------------------------------------- 
      
    if ack2p is  True:
        print('~' *21)                   
        print("(STEP 2/3d) OF PHASE2 OF HELLO_WORLD - ALIVE STATUS AFTER CREATION: ", p2xi.is_alive())  
        print('~' *21)   
        # False - OK
        
        p2xi.start()
        
        print('~' *21)           
        print("(STEP 2/e) OF PHASE2 OF HELLO_WORLD -  ALIVE STATUS AFTER START: ", p2xi.is_alive())     
        print('~' *21)           
        # True - OK
        
        p2xi.run()
        
        print('~' *21)           
        print("(STEP 2/f) OF PHASE2 OF HELLO_WORLD - ALIVE STATUS AFTER RUN: ", p2xi.is_alive()) 
        print('~' *21)               
        #================================================================================
        #(Step 2/3) of hello world from Dragon2Xi multiprocessing2xi!
        #================================================================================         
        # True - OK        
        
        p2xi.terminate()
        print('~' *21)       
        print("(STEP 2/g) OF PHASE2 OF HELLO_WORLD - ALIVE STATUS AFTER TERMINATE: ", p2xi.is_alive())  
        print('~' *21)
        # True - OK     
                   
    else:
        print("(STEP 2/3h) ** OF PHASE2 OF HELLO_WORLD - SKIPPED EXPLORING WITH NON-EXISTING PROCESS2XI ** ", time4xi())    
 
#</function4xi>        
         
         
# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase3" usage = "
#   Hello World from Dragon4Xi
#">                               
# -------------------------------------------------------------------------------------------------           
def phase4(argv=None):
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1/33) OF HELLO_WORLD4XI MAIN - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:   
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3B1-2) - OK 
        # ----------------------------------------------------------------------------------------- 
           
        try:
            cp2xi = CurrentProcess4Xi(False)  # WE WANT TO MAKE MAINPROCESS4XI  TO _CURRENT_PROCESS 
            print("(STEP 3/3B1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  CREATED CURRENT PROCESS4XI OBJECT CP2XI: ", cp2xi)    
            # <current_process4xi.CurrentProcess4Xi object at 0x000000000341E438>
        except:
            print("(STEP 3/3B2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO CREATE CURRENT PROCESS4XI OBJECT CP2XI *** ", time4xi())
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3B3-4) - OK 
        # -----------------------------------------------------------------------------------------     
        try:                
            print("(STEP 3/3B3) OF HELLO_WORLD4XI MAIN:  THE NAME OF THE CURRENT PROCESS OBJECT CP2XI: ", cp2xi.get_name_current())  
            # MainProcess4Xi 
        except:
           print("(STEP 3/3B4) OF HELLO_WORLD4XI MAIN:  *** FAILED WITH NAME OF THE CURRENT PROCESS OBJECT CP2XI *** ", time4xi())
    
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3C1-2) - OK 
        # -----------------------------------------------------------------------------------------      
        try:
            p2xi = Process4Xi(target=f4xi)
            print("(STEP 3/3C1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  CREATED PROCESS OBJECT P2XI: ", p2xi)  
            # <Process4Xi(Process4Xi-1, initial)>
            
        except:
            print("(STEP 3/3C2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO CREATE PROCESS OBJECT P2XI *** ", time4xi())
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3C3-4) - OK 
        # -----------------------------------------------------------------------------------------              
        try:    
            print("(STEP 3/3C3) OF HELLO_WORLD4XI MAIN:  THE NAME OF THE PROCESS OBJECT P2XI: ", p2xi.name)  
            # Process4Xi-1
             
        except:
            print("(STEP 3/3C4) OF HELLO_WORLD4XI MAIN:  *** FAILED WITH THE NAME OF THE PROCESS OBJECT P2XI *** ", time4xi())
            # 
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3D1-2) - tested and skipped now - we wanted this test to be main process 
        # -----------------------------------------------------------------------------------------             
        # try:
        #     print("(STEP 3/3D1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF CURRENT PROCESS CP2XI AFTER CREATION: ")
        #     print(cp2xi.is_alive()) 
        #     #
        # except:
        #     print("(STEP 3/3D2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS CP2XI AFTER CREATION ***")
        #     # (STEP 3/3D2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS CP2XI AFTER CREATION ***
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3D3-4) - OK 
        # -----------------------------------------------------------------------------------------         
        try:    
            print("(STEP 3/3D3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF PROCESS OBJECT P2XI AFTER CREATION: ", p2xi.is_alive()) 
            # False
                   
        except:
            print("(STEP 3/3D4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF PROCESS OBJECT P2XI AFTER CREATION *** ", time4xi())
                
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3E1-2) - tested and skipped now - we wanted this test to be main process 
        # -----------------------------------------------------------------------------------------
        # try:
        #     cp2xi.start() 
        #     print("(STEP 3/3E1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  STARTED CURRENT PROCESS4XI OBJECT CP2XI: ")
        #     print(cp2xi)          
        # except:
        #     print("(STEP 3/3E2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO START CURRENT PROCESS4XI OBJECT CP2XI ***")
        #     # (STEP 3/3E2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO START CURRENT PROCESS4XI OBJECT CP2XI ***
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3E3-4) - OK 
        # -----------------------------------------------------------------------------------------        
        try:              
            p2xi.start() 
            print("(STEP 3/3E3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  STARTED PROCESS OBJECT P2XI: ", p2xi)
            # start-of-Process4Xi-returning: 05:59:29 02/11/13 Pacific Standard Time
        except:
            print("(STEP 3/3E4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO START PROCESS OBJECT P2XI *** ", time4xi())
    
        
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3F1-2) - tested and skipped now - we wanted this test to be main process 
        # ----------------------------------------------------------------------------------------- 
        # try:
        #     print("(STEP 3/3F1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER START: ")
        #     print(cp2xi.is_alive())          
        # except:
        #     print("(STEP 3/3F2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER START *** ")
        #     # *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER START *** 
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3F3-4) - OK 
        # -----------------------------------------------------------------------------------------             
        try:                    
            print("(STEP 3/3F3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF PROCESS OBJECT P2XI AFTER START: ", p2xi.is_alive())  
            # ack2alive-of-process2xi-returning-by-is-alive-of-Process4Xi: True;
        except:
            print("(STEP 3/3F4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF PROCESS OBJECT P2XI AFTER START *** ", time4xi())
     
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3G1-2) - tested and skipped now - we wanted this test to be main process 
        # ----------------------------------------------------------------------------------------- 
        # try:
        #     print("(STEP 3/3G1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  SENSING CURRENT PROCESS OBJECT CP2XI AFTER START: ")
        #     print(cp2xi.sense())        
        # except:
        #     print("(STEP 3/3G2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED SENSING CURRENT PROCESS OBJECT CP2XI AFTER START ***")
        #     # STEP 3/3G2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED SENSING CURRENT PROCESS OBJECT CP2XI AFTER START ***
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3G3-4) - OK
        # -----------------------------------------------------------------------------------------         
        try:                    
            print("(STEP 3/3G3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  SENSING PROCESS OBJECT P2XI AFTER START: ", p2xi.sense())
            # {            'args-of-process2xi': (),
            #          'identity-of-process2xi': (1,), 
            #             'popen-of-process2xi': <popen4xi.Popen4Xi object at 0x02C99810>, 
            #           daemonic-of-process2xi': False, 
            #              'name-of-process2xi': 'Process4Xi-1', 
            #                          'object': <Process4Xi(Process4Xi-1, stopped)>,
            #            'target-of-process2xi': <function f4xi at 0x02C8E7C8>, 
            #           'authkey-of-process2xi': b'\xe5\xf1\xbe\xf9\xd9\x1a\xa1\xbe\xc9\x9c\xa6\xea\xac\x04\x7f\xa7\x87V\xce\xfb\xd8"\xd0\x97\xed\xe8.)\xbd\xa3)\x8c',
            #            'kwargs-of-process2xi': {}, 
            #        'parent_pid-of-process2xi': 2676, 
            #             'Popen-of-Process4Xi': None, 
            #           'tempdir-of-process2xi': 'c:\\users\\ceo4dr~1\\appdata\\local\\temp\\pymp-cr1kfk'}
            # ; time: 00:17:02 04/22/10 Pacific Daylight Time}
            
            #with current_process4Xi in all steps:
            #             {'args-of-process2xi': (),
            #          'identity-of-process2xi': (1,),
            #             'popen-of-process2xi': <popen4xi.Popen4Xi object at 0x02CA8F70>,
            #          'daemonic-of-process2xi': False, 
            #              'name-of-process2xi': 'Process4Xi-1',
            #                          'object': <Process4Xi(Process4Xi-1, stopped)>, 
            #            'target-of-process2xi': <function f4xi at 0x02C9FA08>,
            #           'authkey-of-process2xi': b'\xa1S\xa4r\xa5\x1e,\xfa\xd8}\xda\xf2IO\x91\x80\xc2\x19\x8ds\x86\xa8\x92(\x19\x99I\xc6\xbel.\xb7', 
            #            'kwargs-of-process2xi': {}, 
            #        'parent_pid-of-process2xi': 6080, 
            #             'Popen-of-Process4Xi': None, 
            #           'tempdir-of-process2xi': 'c:\\users\\ceo4dr~1\\appdata\\local\\temp\\pymp-uqiylx'}

            
        except:
            print("(STEP 3/3G4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED SENSING PROCESS OBJECT P2XI AFTER START *** ", time4xi())      
        
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3H1-2) - OK 
        # ----------------------------------------------------------------------------------------- 
        try:
            print("(STEP 3/3H1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  REASONING CURRENT PROCESS OBJECT CP2XI AFTER START: ", cp2xi.reason())        
            # {'object-reason-object4xi': <current_process4xi.CurrentProcess4Xi object at 0x02C92AD0>}
            
        except:
            print("(STEP 3/3H2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED REASONING CURRENT PROCESS OBJECT CP2XI AFTER START ***", time4xi())
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3H3-4) - OK 
        # ----------------------------------------------------------------------------------------- 
        try:                     
            print("(STEP 3/3H3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  REASONING PROCESS OBJECT P2XI AFTER START: ", p2xi.reason())
            # {'object-reason-object4xi': <Process4Xi(Process4Xi-1, stopped)>}
            
        except:
            print("(STEP 3/3H4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED REASONING PROCESS OBJECT P2XI AFTER START *** ", time4xi())
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3H1-2) - OK 
        # -----------------------------------------------------------------------------------------  
        try:
            print("(STEP 3/3H1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ACING CURRENT PROCESS OBJECT CP2XI AFTER START: ", cp2xi.ace())
            # {'object8xi': <current_process4xi.CurrentProcess4Xi object at 0x02C92AD0>}
                    
        except:
            print("(STEP 3/3H2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED ACING CURRENT PROCESS OBJECT CP2XI AFTER START *** ", time4xi())
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3H3-4) - OK 
        # -----------------------------------------------------------------------------------------  
        try:                   
            print("(STEP 3/3H3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ACING PROCESS OBJECT P2XI AFTER START: ", p2xi.ace())
            # {'object8xi': <Process4Xi(Process4Xi-1, stopped)>}
            
        except:
            print("(STEP 3/3H4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED ACING PROCESS OBJECT P2XI AFTER START *** ", time4xi())

            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3I1-2) - tested and skipped now - we wanted this test to be main process
        # ----------------------------------------------------------------------------------------- 
        # try:
        #     cp2xi.run()
        #     
        #     print("(STEP 3/3I1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  PERFORMED RUN COMMAND TO CURRENT PROCESS OBJECT CP2XI: ")
        #     print(cp2xi)
        # except:
        #     print("(STEP 3/3I2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO PERFORM RUN COMMAND TO CURRENT PROCESS OBJECT CP2XI ***")
        #     # (STEP 3/3I2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO PERFORM RUN COMMAND TO CURRENT PROCESS OBJECT CP2XI ***
                        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3I3-4) - 
        # -----------------------------------------------------------------------------------------             
        try:                     
            p2xi.run()
            
            print("(STEP 3/3I3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  PERFORMED RUN COMMAND TO PROCESS OBJECT P2XI: ", p2xi)
            # ================================================================================
            # (Step 3/3) of hello world from Dragon4Xi Multiprocessing4xi!
            # ================================================================================
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # { Process4Xi : run ; Step (1/2b) performed; target-of-process2xi-performed-by-run-of-Process4Xi: <function f4xi at 0x02C9FA08>; time: 08:16:08 04/22/10 Pacific Daylight Time}
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # { Process4Xi : run ; Step (2/2) returning; run-of-Process4Xi-returning: 08:16:08 04/22/10 Pacific Daylight Time}
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # (STEP 3/3I3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  PERFORMED RUN COMMAND TO PROCESS OBJECT P2XI: 
            
        except:
            print("(STEP 3/3I4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO PERFORM RUN COMMAND TO PROCESS OBJECT P2XI *** ", time4xi())
            
 
                    
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3J1-2) - tested and skipped now - we wanted this test to be main process  
        # ----------------------------------------------------------------------------------------- 
        # try:
        #     print("(STEP 3/3J1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER RUN: ")
        #     print(cp2xi.is_alive())         
        # except:
        #     print("(STEP 3/3J2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER RUN *** ")
        #     # (STEP 3/3J2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER RUN *** 
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3J2-3)  - OK 
        # -----------------------------------------------------------------------------------------             
        try:                
            print("(STEP 3/3J3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF PROCESS OBJECT P2XI AFTER RUN: ", p2xi.is_alive()) 
            # True
        except:
            print("(STEP 3/3J4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF PROCESS OBJECT P2XI AFTER RUN *** ", time4xi())
       
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3H1-2) - tested and skipped now - we wanted this test to be main process 
        # ----------------------------------------------------------------------------------------- 
        # try:
        #     print("(STEP 3/3H1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  SENSING CURRENT PROCESS OBJECT CP2XI AFTER RUN: ")
        #     print(cp2xi.sense())
        # except:
        #     print("(STEP 3/3H2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED SENSING CURRENT PROCESS OBJECT CP2XI AFTER RUN ***")
        #     # *** FAILED SENSING CURRENT PROCESS OBJECT CP2XI AFTER RUN ***
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3H3-4) - OK  
        # -----------------------------------------------------------------------------------------             
        try:                        
            print("(STEP 3/3H3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  SENSING PROCESS OBJECT P2XI AFTER RUN: ", p2xi.sense())
            
            # {          'args-of-process2xi': (), 
            #        'identity-of-process2xi': (1,), 
            #           'popen-of-process2xi': <popen4xi.Popen4Xi object at 0x02C99810>, 
            #        'daemonic-of-process2xi': False, 
            #            'name-of-process2xi': 'Process4Xi-1', 
            #                        'object': <Process4Xi(Process4Xi-1, stopped)>, 
            #          'target-of-process2xi': <function f4xi at 0x02C8E7C8>, 
            #         'authkey-of-process2xi': b'\xe5\xf1\xbe\xf9\xd9\x1a\xa1\xbe\xc9\x9c\xa6\xea\xac\x04\x7f\xa7\x87V\xce\xfb\xd8"\xd0\x97\xed\xe8.)\xbd\xa3)\x8c', 
            #          'kwargs-of-process2xi': {}, 
            #      'parent_pid-of-process2xi': 2676, 
            #           'Popen-of-Process4Xi': None, 
            #         'tempdir-of-process2xi': 'c:\\users\\ceo4dr~1\\appdata\\local\\temp\\pymp-cr1kfk'
            # }; time: 00:17:02 04/22/10 Pacific Daylight Time}
            
            # {          'args-of-process2xi': (), 
            #        'identity-of-process2xi': (1,), 
            #           'popen-of-process2xi': <popen4xi.Popen4Xi object at 0x02CA8F70>, 
            #        'daemonic-of-process2xi': False, 
            #            'name-of-process2xi': 'Process4Xi-1', 
            #                        'object': <Process4Xi(Process4Xi-1, stopped)>, 
            #          'target-of-process2xi': <function f4xi at 0x02C9FA08>, 
            #         'authkey-of-process2xi': b'\xa1S\xa4r\xa5\x1e,\xfa\xd8}\xda\xf2IO\x91\x80\xc2\x19\x8ds\x86\xa8\x92(\x19\x99I\xc6\xbel.\xb7', 
            #           kwargs-of-process2xi': {}, 
            #      'parent_pid-of-process2xi': 6080, 
            #           'Popen-of-Process4Xi': None, 
            #         'tempdir-of-process2xi': 'c:\\users\\ceo4dr~1\\appdata\\local\\temp\\pymp-uqiylx'}

            
            
        except:
            print("(STEP 3/3H4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED SENSING PROCESS OBJECT P2XI AFTER RUN *** ", time4xi())
                   
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3L1-3) - tested and skipped now - we wanted this test to be main process 
        # ----------------------------------------------------------------------------------------- 
        
        # print("(STEP 3/3L1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  JOINING CURRENT PROCESS OBJECT CP2XI")    
        # try:
        #     cp2xi.join()
        #     
        #     print("(STEP 3/3L2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  JOINED  CURRENT PROCESS OBJECT CP2XI")
        #     #                  
        # except:
        #     print("(STEP 3/3L3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO JOIN  CURRENT PROCESS OBJECT CP2XI ***")
        #     # STEP 3/3L3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO JOIN  CURRENT PROCESS OBJECT CP2XI ***
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3L4-6) - OK 
        # -----------------------------------------------------------------------------------------                     
        print("(STEP 3/3L4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  JOINING PROCESS OBJECT P2XI ", time4xi()) 
        # 05:59:29 02/11/13 Pacific Standard Time   
        try:
            p2xi.join()
            
            print("(STEP 3/3L5) OF PHASE4 IN HELLO_WORLD4XI MAIN:  JOINED PROCESS OBJECT P2XI ", time4xi())
            # status-set-by-repr-of-Process4Xi to: stopped
            # join-of-Process4Xi-returning: 05:59:29 02/11/13 Pacific Standard Time
        except:
           print("(STEP 3/3L6) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO JOIN PROCESS OBJECT P2XI *** ", time4xi())
           
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3L7-8) - tested and skipped now - we wanted this test to be main process 
        # -----------------------------------------------------------------------------------------         
        # try:       
        #     print("(STEP 3/3L7) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER JOIN: ")
        #     print(cp2xi.is_alive())
        # except:
        #     print("(STEP 3/3L8) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER JOIN ***")
        #     # STEP 3/3L8) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER JOIN ***
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3L9-10) - OK (STOPPED BUT ALIVE)
        # -----------------------------------------------------------------------------------------             
        try:        
            print("(STEP 3/3L9) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF PROCESS OBJECT P2XI AFTER JOIN: ", p2xi.is_alive())                 
            # True
            # 
        except:
            print("(STEP 3/3L10) OF PHASE4 IN HELLO_WORLD4XI MAIN: *** FAILED WITH ALIVE STATUS OF PROCESS OBJECT P2XI AFTER JOIN *** ", time4xi())     
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3M1-3) - tested and skipped now - we wanted this test to be main process    
        # ----------------------------------------------------------------------------------------- 
        # print("(STEP 3/3M1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  BOOTING CURRENT PROCESS OBJECT CP2XI")    
        # 
        # try:    
        #     cp2xi._bootstrap()
        #     
        #     print("(STEP 3/3M2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  BOOTED CURRENT PROCESS OBJECT CP2XI")           
        # except:
        #     print("(STEP 3/3M3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO BOOT CURRENT PROCESS OBJECT CP2XI *** ") 
        #     # (STEP 3/3M3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO BOOT CURRENT PROCESS OBJECT CP2XI *** 
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3M4-6) - OK    
        # -----------------------------------------------------------------------------------------           
        print("(STEP 3/3M4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  BOOTING PROCESS OBJECT P2XI ", time4xi())    
        # 05:59:29 02/11/13 Pacific Standard Time
        try:        
            p2xi._bootstrap()
            
            print("(STEP 3/3M5) OF PHASE4 IN HELLO_WORLD4XI MAIN:  BOOTED PROCESS OBJECT P2XI")    
            # { Process4Xi : _bootstrap ; returning; exitcode-returning-by-bootstrap-of-Process4Xi: 0; time: 00:17:02 04/22/10 Pacific Daylight Time}
            
            # Note: tested that you can not start a process twice:
            # print("(STEP 3/3M5b) OF PHASE4 IN HELLO_WORLD4XI MAIN:  CALLING START AFTER _BOOTSTRAP")        
            # p2xi.start()
            # print("(STEP 3/3M5c) OF PHASE4 IN HELLO_WORLD4XI MAIN:  PERFORMED START AFTER _BOOTSTRAP")       
            # process4xi.py; line 1768 cannot start a process twice .i.e. boot includes start ! 
        except:
            print("(STEP 3/3M6) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO BOOT PROCESS OBJECT P2XI ***", time4xi()) 
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3M7-8) - tested and skipped now - we wanted this test to be main process      
        # -----------------------------------------------------------------------------------------              
        # try:        
        #     print("(STEP 3/3M7) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT: ")
        #     print(cp2xi.is_alive()) 
        #     #                
        # except:
        #     print("(STEP 3/3M8) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT ***")
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3M9-10) - OK    
        # -----------------------------------------------------------------------------------------          
        try:        
            print("(STEP 3/3M9) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF PROCESS OBJECT P2XI AFTER BOOT: ", p2xi.is_alive()) 
            # True
        except:
            print("(STEP 3/3M10) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF PROCESS OBJECT P2XI AFTER BOOT *** ", time4xi())
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3M11-13) - tested and skipped now - we wanted this test to be main process    
        # -----------------------------------------------------------------------------------------                  
        # print("(STEP 3/3M11) OF PHASE4 IN HELLO_WORLD4XI MAIN:  COMMANDING CURRENT PROCESS OBJECT CP2XI TO RUN AFTER _BOOTSTRAP")        
        # 
        # try:
        #     cp2xi.run()
        #             
        #     print("(STEP 3/3M12) OF PHASE4 IN HELLO_WORLD4XI MAIN:  PERFORMED RUN COMMAND TO CURRENT PROCESS OBJECT CP2XI AFTER _BOOTSTRAP")           
        # except:
        #     print("(STEP 3/3M13) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO PERFORM RUN COMMAND TO CURRENT PROCESS OBJECT CP2XI AFTER _BOOTSTRAP ***")   
        
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3M14-13) - OK    
        # -----------------------------------------------------------------------------------------          
        print("(STEP 3/3M14) OF PHASE4 IN HELLO_WORLD4XI MAIN:  COMMANDING PROCESS OBJECT P2XI TO RUN AFTER _BOOTSTRAP", time4xi())      
        # 05:59:30 02/11/13 Pacific Standard Time        
        try:                
            p2xi.run()
            
            print("(STEP 3/3M14) OF PHASE4 IN HELLO_WORLD4XI MAIN:  PERFORMED RUN COMMAND TO PROCESS OBJECT P2XI AFTER _BOOTSTRAP ", time4xi())
            # 05:59:30 02/11/13 Pacific Standard Time       
        except:
            print("(STEP 3/3M15) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO PERFORM RUN COMMAND TO PROCESS OBJECT P2XI AFTER _BOOTSTRAP *** ", time4xi())
             
        # ================================================================================
        # (Step 3/3) of hello world from Dragon4Xi Multiprocessing4xi!
        # ================================================================================
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # { Process4Xi : run ; Step (1/2b) performed; target-of-process2xi-performed-by-run-of-Process4Xi: <function f4xi at 0x02C8E7C8>; time: 00:17:02 04/22/10 Pacific Daylight Time}
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # { Process4Xi : run ; Step (2/2) returning; run-of-Process4Xi-returning: 00:17:02 04/22/10 Pacific Daylight Time}
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3M16-17) - tested and skipped now - we wanted this test to be main process    
        # -----------------------------------------------------------------------------------------  
        # try:
        #     print("(STEP 3/3M16) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT: ")
        #     print(cp2xi.is_alive()) 
        #     #         
        # except:
        #     print("(STEP 3/3M17) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT ***")
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3M18-19) - OK     
        # -----------------------------------------------------------------------------------------             
        try:            
            print("(STEP 3/3M18) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF PROCESS OBJECT P2XI AFTER BOOT: ",p2xi.is_alive()) 
            # True
        except:
            print("(STEP 3/3M19) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF PROCESS OBJECT P2XI AFTER BOOT *** ", time4xi())
               
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3N1-2) - tested and skipped now - we wanted this test to be main process  
        # -----------------------------------------------------------------------------------------     
        # try:
        #     print("(STEP 3/3N1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  SENSING CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ")     
        #     print(cp2xi.sense())        
        # except:
        #     print("(STEP 3/3N2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED SENSING CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN ***")
        #     # (STEP 3/3N2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED SENSING CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN ***
            
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3N3-4) - OK  
        # -----------------------------------------------------------------------------------------                 
        try:
            print("(STEP 3/3N3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  SENSING PROCESS OBJECT P2XI AFTER BOOT AND RUN: ", p2xi.sense())
            # {'           args-of-process2xi': (), 
            #         'identity-of-process2xi': (1,), 
            #            'popen-of-process2xi': <popen4xi.Popen4Xi object at 0x02C99810>, 
            #         'daemonic-of-process2xi': False, 
            #             'name-of-process2xi': 'Process4Xi-1', 
            #                         'object': <Process4Xi(Process4Xi-1, stopped)>, 
            #           'target-of-process2xi': <function f4xi at 0x02C8E7C8>, 
            #          'authkey-of-process2xi': b'\xe5\xf1\xbe\xf9\xd9\x1a\xa1\xbe\xc9\x9c\xa6\xea\xac\x04\x7f\xa7\x87V\xce\xfb\xd8"\xd0\x97\xed\xe8.)\xbd\xa3)\x8c', 
            #           'kwargs-of-process2xi': {}, 
            #       'parent_pid-of-process2xi': 2676, 
            #            'Popen-of-Process4Xi': None, 
            #          'tempdir-of-process2xi': 'c:\\users\\ceo4dr~1\\appdata\\local\\temp\\pymp-cr1kfk'
            #}
        except:
            print("(STEP 3/3N4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED SENSING PROCESS OBJECT P2XI AFTER BOOT AND RUN *** ", time4xi())

        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3N5-6)  - OK  
        # -----------------------------------------------------------------------------------------     
        try:
             print("(STEP 3/3N5) OF PHASE4 IN HELLO_WORLD4XI MAIN:  GETTING INHERITANCE OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ", cp2xi.get_inheriting_current())      
             # True      
        except:
             print("(STEP 3/3N6) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED GETTING INHERITANCE OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN ***")         
             #        
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3N7-8) - OK 
        # -----------------------------------------------------------------------------------------     
        try:
             print("(STEP 3/3N7) OF PHASE4 IN HELLO_WORLD4XI MAIN:  GETTING AUTHKEY OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ", cp2xi.get_authkey_current())     
             # b'\x85\x8f1\xd6\xbaA\xe8\x02\x8e\xa5\x10\x8f\xe2\x8fm\x91\xd1J\xa8\x89\x0e\x06\xafH\x12\xa8\xe13\xe2\x82\x8b\x90'
    
        except:
             print("(STEP 3/3N8) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED GETTING AUTHKEY  OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN *** ", time4xi())         
             #               
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3N9-10) - OK 
        # -----------------------------------------------------------------------------------------     
        try:
             print("(STEP 3/3N9) OF PHASE4 IN HELLO_WORLD4XI MAIN:  GETTING IDENTITY OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ", cp2xi.get_identity_current())     
             # ()    
        except:
             print("(STEP 3/3N10) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED GETTING IDENTITY OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN *** ", time4xi())         
             #               
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3N11-12) -  OK
        # -----------------------------------------------------------------------------------------     
        try:
             print("(STEP 3/3N11) OF PHASE4 IN HELLO_WORLD4XI MAIN:  GETTING NAME OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ", cp2xi.get_name_current())     
             # MainProcess4Xi        
        except:
             print("(STEP 3/3N12) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED GETTING NAME OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN *** ", time4xi())         
             #                           
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3N13-14) -  OK
        # -----------------------------------------------------------------------------------------     
        try:
             print("(STEP 3/3N13) OF PHASE4 IN HELLO_WORLD4XI MAIN:  GETTING COUNTER OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ", cp2xi.get_counter_current())     
             # count(2)        
        except:
             print("(STEP 3/3N14) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED GETTING COUNTER OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN *** ", time4xi())         
             # 
             
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3N15-16) -  OK
        # -----------------------------------------------------------------------------------------     
        try:
             print("(STEP 3/3N15) OF PHASE4 IN HELLO_WORLD4XI MAIN:  GETTING DAEMONIC OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ", cp2xi.get_daemonic_current())     
             # False         
        except:
             print("(STEP 3/3N16) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED GETTING DAEMONIC OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN *** ", time4xi())         
             #    
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3N15-16) -  OK 
        # -----------------------------------------------------------------------------------------     
        try:
             print("(STEP 3/3N15) OF PHASE4 IN HELLO_WORLD4XI MAIN:  GETTING TEMPORARY DIRECTORY OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ", cp2xi.get_tempdir_current())     
             #         
        except:
             print("(STEP 3/3N16) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED GETTING TEMPORARY DIRECTORY OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN ***", time4xi())         
             # d:\users\ceo4dr~1\appdata\local\temp\pymp-n7booz  
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3N17-18) -  OK 
        # -----------------------------------------------------------------------------------------     
        try:
             print("(STEP 3/3N17) OF PHASE4 IN HELLO_WORLD4XI MAIN:  GETTING CHILDREN OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ", cp2xi.get_children_current())     
             # set()   
        except:
             print("(STEP 3/3N18) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED GETTING CHILDREN DIRECTORY OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN ***", time4xi())         
             #    
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3N19-20) - OK 
        # -----------------------------------------------------------------------------------------     
        try:
             print("(STEP 3/3N19) OF PHASE4 IN HELLO_WORLD4XI MAIN:  GETTING MANAGER OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ", cp2xi.get_manager_server_current())     
             # <current_process4xi.CurrentProcess4Xi object at 0x000000000341E278>     
        except:
             print("(STEP 3/3N20) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED GETTING MANAGER DIRECTORY OF CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN ***", time4xi())         
             #    
                                                                                                           
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3O1-2) - OK 
        # -----------------------------------------------------------------------------------------     
        try:
            print("(STEP 3/3O1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  REASONING CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ", cp2xi.reason())
            # {'object-reason-object4xi': <current_process4xi.CurrentProcess4Xi object at 0x02B52AD0>}
                    
        except:
            print("(STEP 3/3O2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED REASONING CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN *** ", time4xi())
            
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3O3-4) - OK
        # -----------------------------------------------------------------------------------------             
        try:     
            print("(STEP 3/3O3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  REASONING PROCESS OBJECT P2XI AFTER BOOT AND RUN: ", p2xi.reason())
            # {'object-reason-object4xi': <Process4Xi(Process4Xi-1, stopped)>}
            
        except:
            print("(STEP 3/3O4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED REASONING PROCESS OBJECT P2XI AFTER BOOT AND RUN ***", time4xi())
             
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3P1-2) - OK
        # -----------------------------------------------------------------------------------------     
        try:
            print("(STEP 3/3P1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ACING CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN: ", cp2xi.ace())
            # {'object8xi': <current_process4xi.CurrentProcess4Xi object at 0x02B52AD0>}
            
        except:
            print("(STEP 3/3P2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED ACING CURRENT PROCESS OBJECT CP2XI AFTER BOOT AND RUN *** ", time4xi())
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3P3-4) - OK
        # -----------------------------------------------------------------------------------------                
        try:     
            print("(STEP 3/3P3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ACING PROCESS OBJECT P2XI AFTER BOOT AND RUN: ", p2xi.ace())
            # {'object8xi': <Process4Xi(Process4Xi-1, stopped)>}
            
        except:
            print("(STEP 3/3P4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED ACING PROCESS OBJECT P2XI AFTER BOOT AND RUN ***", time4xi())
             
                       
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3Q1-2) - tested and skipped now - we wanted this test to be main process   
        # -----------------------------------------------------------------------------------------  
        # try:
        #     print("(STEP 3/3Q1) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI BEFORE TERMINATION: ")
        #     print(cp2xi.is_alive())      
        # except:
        #     print("(STEP 3/3Q2) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI BEFORE TERMINATION ***")
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3Q3-4) - OK   
        # -----------------------------------------------------------------------------------------              
        try:               
            print("(STEP 3/3Q3) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF PROCESS OBJECT P2XI BEFORE TERMINATION: ", p2xi.is_alive())
            # True
                          
        except:
            print("(STEP 3/3Q4) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF PROCESS OBJECT P2XI BEFORE TERMINATION *** ", time4xi())
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3Q5-6) - tested and skipped now - we wanted this test to be main process    
        # -----------------------------------------------------------------------------------------              
        # try:
        #     cp2xi.terminate()
        #     
        #     print("(STEP 3/3Q5) OF PHASE4 IN HELLO_WORLD4XI MAIN:  TERMINATED CURRENT PROCESS OBJECT CP2XI: ")
        #     print(cp2xi)        
        # except:
        #     print("(STEP 3/3Q6) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO TERMINATE CURRENT PROCESS OBJECT CP2XI *** ")
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3Q7-8)   
        # -----------------------------------------------------------------------------------------                 
        try:
            p2xi.terminate()
            
            print("(STEP 3/3Q7) OF PHASE4 IN HELLO_WORLD4XI MAIN:  TERMINATED PROCESS OBJECT P2XI: ", p2xi)
            # terminate-of-Process4Xi-returning: 05:59:30 02/11/13 Pacific Standard Time
            
        except:
            print("(STEP 3/3Q8) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED TO TERMINATE PROCESS OBJECT P2XI *** ", time4xi())
            
        # -----------------------------------------------------------------------------------------    
        # (STEP 3/3Q9-10) - tested and skipped now - we wanted this test to be main process       
        # -----------------------------------------------------------------------------------------              
        # try: 
        #     print("(STEP 3/3Q9) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER TERMINATION: ")
        #     print(cp2xi.is_alive())                
        # except:
        #     print("(STEP 3/3Q10) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF CURRENT PROCESS OBJECT CP2XI AFTER TERMINATION ***")
            
        # ------------------------------------------------------------------- ----------------------    
        # (STEP 3/3Q11-12)    
        # -----------------------------------------------------------------------------------------         
        try:        
            print("(STEP 3/3Q11) OF PHASE4 IN HELLO_WORLD4XI MAIN:  ALIVE STATUS OF PROCESS OBJECT P2XI AFTER TERMINATION: ", p2xi.is_alive())
            # True         
        except:
            print("(STEP 3/3Q12) OF PHASE4 IN HELLO_WORLD4XI MAIN:  *** FAILED WITH ALIVE STATUS OF PROCESS OBJECT P2XI AFTER TERMINATION ***", time4xi())
        
                      
        # -----------------------------------------------------------------------------------------    
        # ALL: OK  
        # -----------------------------------------------------------------------------------------
        print("(ALL STEPS) OF PHASE4 IN HELLO_WORLD4XI MAIN COMPLETED ", time4xi())
        # 05:59:30 02/11/13 Pacific Standard Time
    except:    
        
        print(" *** FAILED TO COMPLETE ALL STEP OF PHASE4 IN HELLO WORLD4XI *** ", time4xi())
        
    finally:    
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main of hello_world4xi
#">                               
# -------------------------------------------------------------------------------------------------           
def main(argv=None):

        
    # -----------------------------------------------------------------------------------------    
    # (STEP 1/3)
    # -----------------------------------------------------------------------------------------    
    print('=' *33)
    print("\n (STEP 1/3) PHASE 1 OF HELLO_WORLD4XI - STANDARD MULTIPROCESSING ", time4xi())
    print('=' *33)
    # 05:59:28 02/11/13 Pacific Standard Time
    phase1()
            
    
    # -----------------------------------------------------------------------------------------    
    # (STEP 2/3)
    # -----------------------------------------------------------------------------------------    
    print('=' *33)
    print("\n (STEP 2/3) PHASE 2 OF HELLO_WORLD4XI - DRAGON2XI MULTIPROCESSING ", time4xi())
    # 05:59:28 02/11/13 Pacific Standard Time
    print('=' *33)
    phase2()
    
    # -----------------------------------------------------------------------------------------    
    # (Step 3/3)
    # -----------------------------------------------------------------------------------------     
    print('=' *33)
    print("\n (Step 3/3) PHASE 4 OF HELLO_WORLD4XI - DRAGON4XI MULTIPROCESSING ", time4xi())
    # 05:59:28 02/11/13 Pacific Standard Time
    print('=' *33)
    
    phase4()
    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    
   
    main()
      
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_hello_world4xi.txt
#   sense-hello-world4xi.xml
#   reason-hello-world4xi.xml
#   ace-hello-world4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of hello_world4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

    